#!/usr/bin/perl -w

use strict;

sub truth ($) {
    my $s = shift;
    return 1 if ($s eq "TRUE");
    return 0 if ($s eq "FALSE");
    die ("the horror!");
}

my $tasks = -1;
my $U = -1;
my $n = -1;

my $p; my $np;
my $p_lock;
my $pt_g; my $pt_a;
my $npt_g; my $npt_a;

my %sets;
my $total_sets;

my %t_p; my %t_np;
my %t_p_lock;
my %t_pt_g; my %t_pt_a;
my %t_npt_g; my %t_npt_a;

while (my $line = <STDIN>) {

    if ($line =~ /([0-9]+) : U = ([0-9\.]+) : num tasks = ([0-9]+)/) {
	$n = $1;
	$U = $2;
	$tasks = $3;

	$total_sets++;
	$sets{$tasks}++;
	
	next;
    }

    if ($line =~ /assigning priorities:  preemptive: ([A-Z]+),  nonpreemptive: ([A-Z]+)/) {
	$p = truth ($1);
	$np = truth ($2);
	next;
    }

    if ($line =~ /target with PT support\): greedy: ([A-Z]+), anneal: ([A-Z]+)/) {
	$pt_g = truth ($1);
	$pt_a = truth ($2);
	next;
    }

    if ($line =~ /assigning priorities: ([A-Z]+) for clusters implemented using locks/) {
	$p_lock = truth ($1);
	next;
    }

    if ($line =~ /target without PT support\): greedy: ([A-Z]+), anneal: ([A-Z]+)/) {
	$npt_g = truth ($1);
	$npt_a = truth ($2);
	next;
    }

    if ($line =~ /countme/) {
	# print "$tasks $n : $p $np $pt_g $pt_a $npt_g $npt_a\n";
	$t_p{$tasks} += $p;
	$t_p_lock{$tasks} += $p_lock;
	$t_np{$tasks} += $np;
	$t_pt_g{$tasks} += $pt_g;
	$t_pt_a{$tasks} += $pt_a;
	$t_npt_g{$tasks} += $npt_g;
	$t_npt_a{$tasks} += $npt_a;
    }
}

sub bynum {
    return $a <=> $b;
}

#print "\n\n";
foreach (sort bynum keys %t_p) {
    print "$_ :\n";
    print "  p= $t_p{$_}  np= $t_np{$_}  p_lock= $t_p_lock{$_}\n";
    print "  pt_greedy= $t_pt_g{$_}  pt_anneal= $t_pt_a{$_}\n";
    print "  npt_greedy= $t_npt_g{$_}  npt_anneal= $t_npt_a{$_}\n";
    print "  task sets examined = $sets{$_}\n";
}

print "\ntotal sets = $total_sets\n";
