#!/usr/bin/perl -w

use strict;

my $p;
my $np;
my $pt;
my $p_o;
my $np_o;
my $pt_o;

my %P;
my %NP;
my %PT;
my %P_O;
my %NP_O;
my %PT_O;
my %PT_PT_O;

my $unopt_ready;

my $BINS_PER_UNIT;
my $BIN_SIZE;

sub init ()
{
    %P = ();
    %NP = ();
    %PT = ();
    %P_O = ();
    %NP_O = ();
    %PT_O = ();
    %PT_PT_O = ();
    
    $unopt_ready = 0;
    
    $BINS_PER_UNIT = 20;
    $BIN_SIZE = 1.0 / $BINS_PER_UNIT;
}

sub add_bin ($$)
{
    my $hr = shift;
    my %h = %$hr;
    my $val = shift;

    if ($val != -1) {
	$val = int ($val * $BINS_PER_UNIT);
	$$hr{$val}++;
    }
}

sub process_line ($)
{
    my $line = shift;
    chop $line;
    if ($line =~ /([a-z\-]*) CS: unoptimized ([0-9\.\-]+),  optimized ([0-9\.\-]+)$/) {
	my $which = $1;
	my $no = $2;
	my $o = $3;
	if ($which eq "preemptive") {
	    add_bin (\%P, $no);
	    add_bin (\%P_O, $o);
	} elsif ($which eq "non-preemptive") {
	    add_bin (\%NP, $no);
	    add_bin (\%NP_O, $o);
	} else {
	    die;
	}
    } else {
	die if ($line =~ /optim/);
    }
}

sub bynum {
    return $a <=> $b;
}

sub print_bins ($$)
{
    my $hr = shift;
    my %h = %$hr;
    my $fn = shift;

    open OF, ">$fn.dat" or die;
    foreach my $key (sort bynum keys %h) {
	print OF ($key/$BINS_PER_UNIT)." $h{$key}\n";
    }
    close OF;
}

sub finish ()
{
    print_bins (\%P, "p");
    print_bins (\%NP, "np");
    print_bins (\%PT, "pt");
    print_bins (\%P_O, "p_o");
    print_bins (\%NP_O, "np_o");
    print_bins (\%PT_O, "pt_o");
    print_bins (\%PT_PT_O, "pt_pt_o");
}

init ();    
while (my $line = <STDIN>) {
    process_line ($line);
}
finish ();

print "done.\n";
