#!/usr/bin/perl -w

use strict;

my $n;
my $csf;

my %cs;
my %total;

while (my $line = <STDIN>) {
    if ($line =~ /([0-9]+) : U = ([0-9\.]+) : num tasks = ([0-9]+)/) {
	$n = $3;
    }
    if ($line =~ /with fewest threads \(cs = ([0-9\.]+), threads = 1\)/) {
	$csf = $1;
    }
    if ($line =~ /largest critical scaling factor is the same/ ||
	$line =~ /largest critical scaling factor \(cs = ([0-9\.]+),/) {
	if (defined ($1)) {
	    my @l = ($csf, $1);
	    push @{$cs{$n}}, \@l;
	}
	$total{$n}++;
    }
}

sub bynum {
    $a <=> $b;
}

foreach my $t (sort bynum keys %total) {
    my @list = @{$cs{$t}};
    my $tt;
    my $tpct;
    foreach my $lref (@list) {
	my @list2 = @{$lref};
	my $csfx = shift @list2;
	my $csmx = shift @list2;
	my $pct = 100 * ($csfx-1.0) / ($csmx-1.0);
	my $ipct = int ($pct+0.5);
	$tpct += $pct;
	# print "    $csfx $csmx ($ipct %)\n";
	$tt++;
    }
    my $apct = int (0.5 + ($tpct / $tt));
    print "$t tasks, $tt out of $total{$t} task sets;  ";
    print "average of $apct % gain in headroom\n";
}
