#!/usr/bin/perl -w

use strict;

my $n;
my $csf;

my %cs;
my %total;

while (my $line = <STDIN>) {
    if ($line =~ /([0-9]+) : U = ([0-9\.]+) : num tasks = ([0-9]+)/) {
	$n = $3;
	$total{$n}++;
    }

    if ($line =~ /preemptive CS: unoptimized ([0-9\.]+),  optimized ([0-9\.]+)/) {
	my @l = ($1, $2);
	push @{$cs{$n}}, \@l;
    }
}

sub bynum {
    $a <=> $b;
}

sub median ($$) {
    my $lref = shift;
    my $n = shift;
    my @list = @{$lref};
    return (sort bynum @list)[$n/2];
}

foreach my $t (sort bynum keys %total) {
    my @list = @{$cs{$t}};
    my $n;
    my $tu;
    my $to;
    my @ul;
    my @ol;
    foreach my $lref (@list) {
	$n++;
	(my $u, my $o) = @{$lref};
	$tu += $u;
	$to += $o;
	push @ul, $u;
	push @ol, $o;
    }
    my $avgu = $tu / $n;
    my $avgo = $to / $n;
    my $medu = median (\@ul, $n);
    my $medo = median (\@ol, $n);
    my $inc = (100 * (($medo-1.0) / ($medu-1.0))) - 100;
    print "$t tasks, $n / $total{$t} : ";
    # print "avg unoptimized $avgu, optimized $avgo\n";
    print "med unopt $medu, opt $medo, inc = $inc\n";
}
